Index: src/Fl_Graphics_Driver.cxx
===================================================================
--- src/Fl_Graphics_Driver.cxx	(Revision 12438)
+++ src/Fl_Graphics_Driver.cxx	(Arbeitskopie)
@@ -192,6 +192,8 @@
  \param shared shared image to be drawn
  \param X,Y top-left position of the drawn image */
 void Fl_Graphics_Driver::draw(Fl_Shared_Image *shared, int X, int Y) {
+  if (shared->fail())
+    return;
   if ( shared->w() == shared->image_->w() && shared->h() == shared->image_->h()) {
     shared->image_->draw(X, Y, shared->w(), shared->h(), 0, 0);
     return;
Index: src/Fl_Image.cxx
===================================================================
--- src/Fl_Image.cxx	(Revision 12438)
+++ src/Fl_Image.cxx	(Arbeitskopie)
@@ -165,7 +165,10 @@
 int Fl_Image::fail()
 {
     // if no image exists, ld_ may contain a simple error code
-    if ( (w_<=0) || (h_<=0) || (d_<=0) ) {
+    bool failed = w_<=0 || h_<=0 || !count_;
+    if (!failed)
+      (failed = count_==1 && d_!=0) || (count_ >=1 && d_<=0);
+    if ( failed ) {
         if (ld_==0)
             return ERR_NO_IMAGE;
         else
Index: test/pixmap_browser.cxx
===================================================================
--- test/pixmap_browser.cxx	(Revision 12438)
+++ test/pixmap_browser.cxx	(Arbeitskopie)
@@ -62,7 +62,7 @@
   b->labelsize(14);
   b->labelcolor(FL_FOREGROUND_COLOR);
   b->image(img);
-  img->scale(b->w(), b->h());
+  img->scale(b->w(), b->h(), 1, 1);
   b->label(NULL);
   b->redraw();
 }
